// HTML_PIC2SXPage.cpp: implementation of the HTML_PIC2SXPage class.
//
//////////////////////////////////////////////////////////////////////

#include "../../CodeGenerators/HTML/HTML_all.h"
#include "MPASMFileLine.h"
#include "HTML_PIC2SXPage.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

HTML_PIC2SXPage::HTML_PIC2SXPage()
{

}

HTML_PIC2SXPage::~HTML_PIC2SXPage()
{

}

HTML_PIC2SXPage* 
HTML_PIC2SXPage::generatePage()
{
	doc->setTitle("Code converter from MPASM to SASM");
	doc->newTag("H1")->write("Code converter from MPASM to SASM");

	form = doc->newForm();
	form->setAction("/cgi-bin/mpasm2sasm2.exe");
	form->setMethod("post");


	table = form->newTable();
	table
		->setCellspacing("10");

	cell1 = table->newRow()->newCell();
	cell1
		->setColspan("2")
		->setAlign("center")
		->newFont()
			->setColor("darkblue")
			->setFace("Arial Black")
			->write("Paste the PIC assembly code to the text field below");
	table->newRow()->newCell()
		->setColspan("2")
		->newTextArea()
			->setWrap("off")
			->setCols("80")
			->setRows("25")
			->setName("mpasm")
			->write(getInput());
	row1 = table->newRow();
	cell1 = row1->newCell();
	cell1->newInput("Checkbox")
			->setChecked(MPASMFileLine::lowerCase)
			->setName("lowercase")
			->write("Generate lower case mnemonics")
			->br();
	cell1->newInput("Checkbox")
			->setChecked(MPASMFileLine::echoSourceLine)
			->setName("echo")
			->write("Keep commented source lines")
			->br();
	cell1->newInput("Checkbox")
			->setChecked(MPASMFileLine::fixConstantsInComments)
			->setName("comments")
			->write("Convert constants in comments");

	cell1 = row1->newCell();
	cell1
		->write("Default radix in source:")
		->br()
		->newInput("Radio")
			->setNameAndValue("radix", "dec")
			->setChecked(MPASMFileLine::radix == 10)
			->write("Decimal")
			->br();
	cell1->newInput("Radio")
		->setNameAndValue("radix", "hex")
		->setChecked(MPASMFileLine::radix == 16)
		->write("Hexadecimal");

	table->newRow()->newCell()
		->setColspan("2")
		->setAlign("center")
		->newInput("Submit")
			->setNameAndValue("convert", "Convert to SX assembly! >>");
	return(this);
}

const char*
HTML_PIC2SXPage::getInput()
{
	return(input.c_str());
}

HTML_PIC2SXPage* 
HTML_PIC2SXPage::setInput(const char* x)
{
	input = x;
	return(this);
}

