// HTML_PIC2SXPage2.cpp: implementation of the HTML_PIC2SXPage2 class.
//
//////////////////////////////////////////////////////////////////////

#include "../../CodeGenerators/HTML/HTML.h"
#include "MPASMFileLine.h"
#include "HTML_PIC2SXPage2.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

HTML_PIC2SXPage2::HTML_PIC2SXPage2()
{

}

HTML_PIC2SXPage2::~HTML_PIC2SXPage2()
{

}

HTML_PIC2SXPage2* 
HTML_PIC2SXPage2::setOutput(const char* x)
{
	output = x;
	return(this);
}

const char*
HTML_PIC2SXPage2::getOutput()
{
	return(output.c_str());
}

HTML_PIC2SXPage* 
HTML_PIC2SXPage2::generatePage()
{
	translateInput();

	doc->setTitle("Code converter from MPASM to SASM");
	doc->newTag("H1")->write("Code converter from MPASM to SASM");

	form = doc->newForm();
	form->setAction("/cgi-bin/mpasm2sasm2.exe");
	form->setMethod("post");


	table = form->newTable();
	table
		->setCellspacing("10");

	cell1 = table->newRow()->newCell();
	cell1
		->setColspan("2")
		->setAlign("center")
		->newFont()
			->setColor("darkblue")
			->setFace("Arial Black")
			->write("Converted code:");
	table->newRow()->newCell()
		->setColspan("2")
		->newTextArea()
			->setWrap("off")
			->setCols("80")
			->setRows("25")
			->write(getOutput());

	table->newRow()->newCell()
		->setColspan("2")
		->setAlign("center")
		->newInput("Submit")
			->setNameAndValue("back", "<< Back");

	form->newInput("Hidden")
		->setNameAndValue("lowercase", MPASMFileLine::lowerCase? "on" : "off");
	form->newInput("Hidden")
		->setNameAndValue("echo", MPASMFileLine::echoSourceLine? "on" : "off");
	form->newInput("Hidden")
		->setNameAndValue("comments", MPASMFileLine::fixConstantsInComments? "on" : "off");
	form->newInput("Hidden")
		->setNameAndValue("radix", (MPASMFileLine::radix == 10) ? "dec" : "hex");

	return(this);
}

HTML_PIC2SXPage2* 
HTML_PIC2SXPage2::translateInput()
{
	MPASMFileLine x;
	int start = 0;
	FILE* fout;
	char ch[2]=" ";
	fpos_t filestart=0;

	//create temporary file
	fout = tmpfile();
	if(fout != NULL)
	{
		//file created - translate input
		while(start != -1)
		{
			x.initialize();
			x.readSourceLine(input, start);
			x.extractMnemonic();
			x.translateLineTo(fout);
		}
		//read file to output string
		fsetpos(fout, &filestart);
		while((ch[0] = fgetc(fout)) != EOF)
		{
			output.append(ch);
		}
		//close file
		fclose(fout);
	}
	else
	{
		//failed to create file
		setOutput("File operation error!!!");
	}
	return(this);
}
